// Xanadu/ViI2/Ys(PC-98,2DD/2HD)t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <direct.h>
#include "d88.h"

static unsigned char buff[0x400*5*154/2];	// 1024byte x 5sector x 154/2track
static unsigned char dir[0x400*5];
static char dirpath[FILENAME_MAX];				// 쐬fBNg

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
//	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

bool fsave(char *_fname, unsigned char *_pt, int _size)
{
	fp = fopen(_fname,"wb");
//	printf ("cutting ... %s\n",_fname);
	fwrite(_pt, 1, _size, fp);
	fclose(fp);
	return true;
}

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int diskno,numdisk,i,fn,media;
	int h;
	int s_trk,s_sec,e_trk,e_sec,size;
	int x98flag=0;

	if (argc<2 && argc>4)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	disk.SelectDisk(0);
	media = disk.GetDiskType();	
	if (media==disk.TYPE_2HD || media==disk.TYPE_2DD)
	{
		printf("2DD/2HD(PC98)F܂.\n");
	}
	else
	{
		fprintf(stderr, "Ή̃fBXNC[W`ł.\n");
		return 1;
	}
	disk.SetRecordRange(0x01,0x05);
	// Disk 2
	for (h=0; h<2; h++)
	{
		// Cyl.1ȍ~ЖʂۂƓǂݍ
		for (i=1; i<154/2; i++)
		{
			disk.ReadDATA(i*2+h, i>>1, i&1, 1, 0x03, &buff[0x400*5*i], 0x400*5);
		}
		// fBNgǂݍ
		disk.ReadDATA(0x02+h, 0x00, 0x01, 0x01, 0x03, dir, 0x400*5);

		for (fn=0; fn<(sizeof(dir)/0x10); fn++)
		{
			unsigned char *ent = &dir[fn*0x10];
			if (*ent == 0xff) break;	// fBNg̍Ō
			int i;
			int fnp = 0;
			for (i=0x00; i<0x06; i++)
			{
				char c = ent[i];		// t@CPo
				if (c==' ') break;
				fname[fnp++] = c;		// t@C\
			}
			fname[fnp++] = '\0';		// ̍Ō

			s_trk  = *(ent+0x0c);		// JngbN
			s_sec  = *(ent+0x0d);		// JnZN^
			e_trk  = *(ent+0x0e);		// IgbN
			e_sec  = *(ent+0x0f);		// IZN^
			size = ((e_trk*5+e_sec)-(s_trk*5+s_sec)+1)*0x400;	// TCYvZ

			printf("%-9s  START:%02x %02x    END:%02x %02x   SIZE:%04x\n",fname,s_trk,s_sec,e_trk,e_sec,size);
			if (!strcmp(fname,"m.0000")) x98flag=1;		// Ui2
			fsave(fname, &buff[(s_trk*5+s_sec-1)*0x400], size);
		}
	}
	if (x98flag)
	{
		// Xanadu ViI2 IPL
		disk.SetRecordRange(0x01,0x1a);
		disk.ReadDATA(0x00, 0x00, 0x00, 0x01, 0x00, buff, 0xe00);
		fsave("IPLMUS",&buff[0x680],0x181);
	}
	return 0;
}

